<template>
    <div class="edit-popup">

        <popup ref="popupRef" :title="popupTitle" :async="true" width="550px" @confirm="handleSubmit" @close="handleClose">

            <el-form ref="formRef" :model="formData" label-width="auto" :rules="formRules">
                <el-row :gutter="10">
                    <el-col :span="24">
                        <el-form-item label="组织名称" prop="org_id"
                            :rules="[{ required: true, message: '不可为空', trigger: 'blur' }]">
                            <el-select v-model="formData.org_id" clearable placeholder="请选择组织" @change="deptrmt"
                                class="flex-1">
                                <el-option v-for="(item, index) in list1" :key="index" :label="item.name"
                                    :value="item.id" />
                            </el-select>
                        </el-form-item>
                    </el-col>

                    <el-col :span="24">
                        <el-form-item label="部门名称" prop="dept_id"
                            :rules="[{ required: true, message: '不可为空', trigger: 'blur' }]">
                            <el-select v-model="formData.dept_id" clearable placeholder="请选择部门" class="flex-1">
                                <el-option v-for="( item, index ) in  list2 " :key="index" :label="item.name"
                                    :value="item.id" />
                            </el-select>
                        </el-form-item>
                    </el-col>



                    <el-col :span="24">
                        <el-form-item label="规范名称" prop="name">
                            <el-input v-model="formData.name" clearable placeholder="请输入规范名称" />
                        </el-form-item>
                    </el-col>
                    <el-col :span="24">
                        <el-form-item label="规范类别" prop="type">
                            <el-input v-model="formData.type" clearable placeholder="请输入规范类别" />

                        </el-form-item>
                    </el-col>
                    <el-col :span="24">
                        <el-form-item label="发布部门" prop="release_dept">
                            <el-input v-model="formData.release_dept" clearable placeholder="请输入发布部门" />
                        </el-form-item>
                    </el-col>
                    <el-col :span="24">
                        <el-form-item label="发布时间" prop="release_date">
                            <el-date-picker v-model="formData.release_date" clearable type="date" value-format="YYYY-MM-DD"
                                placeholder="选择发布时间" class="flex-1 !flex">
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                    <el-col :span="24">
                        <el-form-item label="内容" prop="content">
                            <el-input v-model="formData.content" type="textarea" clearable placeholder="请输入内容" />
                        </el-form-item>
                    </el-col>
                    <el-col :span="24">

                        <el-form-item label="附件" prop="field127">
                            <el-upload
                                accept="doc, docx, xls, xlsx, ppt, pptx, pdf, txt, zip, rar, tar, jpg, png, gif, jpeg, webp, wmv, avi, mpg, mpeg, 3gp, mov, mp4, flv, f4v, rmvb, mkv"
                                class="upload-demo" :show-file-list="false" aria-hidden="true"
                                :headers="{ Token: userStore.token }" :action="base_url + '/upload/file'"
                                :on-success="handleAvatarSuccess_four" ref="upload">
                                <el-button type="primary">
                                    上传
                                </el-button>
                            </el-upload>

                            <div>
                                <div v-for="( item, index ) in  formDataannex " style="margin-left: 5px;display: block;">
                                    <a style="margin-left: 10px; color: #4a5dff; align-self: flex-start" :href="item.uri"
                                        target="_blank">{{ item.name }}</a>
                                    <span style="cursor: pointer;margin-left: 5px;" @click="delFileFn(index)">x</span>
                                </div>
                            </div>

                        </el-form-item>
                    </el-col>
                </el-row>





            </el-form>
        </popup>

    </div>
</template>

<script lang="ts" setup name="projectEdit">

import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { qualityspecificationAdd, qualityspecificationEdit, qualityspecificationDetail } from '@/api/quality_specification'
import { toChinesNum } from "@/utils/util";
import { getAllProjectTypes } from '@/api/projecttype'
import { timeFormat } from '@/utils/util'
import { isEmail, isIdCard, isPhone } from '@/utils/validate'
import type { PropType } from 'vue'
import configs from "@/config"
import useUserStore from "@/stores/modules/user";
const protype = reactive([])
const base_url = configs.baseUrl + configs.urlPrefix
const userStore = useUserStore();
const active = ref(0)
const formDataannex = reactive([])
const list1 = reactive([])
const list2 = reactive([])
import { deptAll } from '@/api/org/department'
import { getAll } from '@/api/org/organization'
const userInfo = userStore.userInfo
console.log(userInfo, '222222')
// 上传文件
const handleAvatarSuccess_four = (
    response,
    uploadFile
) => {
    if (response.code == 0) {
        ElMessage.error(response.msg);
        return;
    }
    formDataannex.push(
        { uri: response.data.uri, name: response.data.name }


    );
};

// 删除上传的文件
const delFileFn = (index: number) => {
    formDataannex.splice(index, 1)
}
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


//获取所有组织
const getlist = () => {
    getAll().then((res) => {
        Object.assign(list1, res)

    })
}
//获取部门
const deptrmt = (e: any) => {
    formData.dept_id = ''
    getlist1(e)

}
//获取所有部门
const getlist1 = (id: any) => {
    deptAll({ 'org_id': id }).then((res) => {
        list2.splice(0, list2.length, ...res)
    })
}

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑质量规范表' : '新增质量规范表'
})

// 表单数据
const formData = reactive({
    id: '',
    release_dept: "",
    content: "",
    file: [],
    name: "",
    type: "",
    release_date: "",
    dept_id: '',
    org_id: "",

})


// 表单验证
const formRules = reactive<any>({

})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    if (data.file && data.file.length > 0) {

        const arry1 = data.file.map((item: any, index: any) => {
            return {
                name: `文件${index + 1}`,
                uri: item
            };
        });
        Object.assign(formDataannex, arry1)

    }


    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    if (data.dept_id) {
        getlist1(data.dept_id
        )
    }



}
const getDetail = async (row: Record<string, any>) => {
    const data = await qualityspecificationDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    formData.file = formDataannex.map((item) => item.uri)
    await formRef.value?.validate()
    const data = { ...formData }
    mode.value == 'edit'
        ? await qualityspecificationEdit(data)
        : await qualityspecificationAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
    getlist()

}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
